/*
 * *****************************************************************
 * *                                                               *
 * *   Copyright 2002 Compaq Information Technologies Group, L.P.  *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Compaq    *
 * *   Computer Corporation.  Possession, use,  duplication  or    *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Compaq Computer    *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * HISTORY
 */
#ifndef lint
static char     *sccsid = "@(#)$RCSfile: device_data.c,v $ $Revision: 1.1.24.3 $ (DEC) $Date: 2002/07/16 19:42:31 $";
#endif lint

/************************************************************************
 *									*
 *			Copyright (c) 1987 by				*
 *		Digital Equipment Corporation, Maynard, MA		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person.  No title to and	*
 *   ownership of the software is hereby transferred.			*
 *									*
 *   The information in this software is subject to change  without	*
 *   notice  and should not be construed as a commitment by Digital	*
 *   Equipment Corporation.						*
 *									*
 *   Digital assumes no responsibility for the use  or  reliability	*
 *   of its software on equipment which is not supplied by Digital.	*
 *									*
 ************************************************************************/


/************************************************************************
 *									
 * Name: tables.c
 *
 * Modification History
 * 
 *
 ***********************************************************************/

#include <arch/alpha/hal/cpuconf.h>
#include <arch/alpha/hal/device_tables.h>
/*
 * Function prototypes 
 */


/********************************************************************
 *
 * Table Structure for configuring the NODE information.
 *
 *******************************************************************/
volatile struct config_node nodetbl[] = {
    { "bi",		"node",		BINODE	        },
    { "xmi",		"node",		XMINODE		},
    { "ci",		"cinode",	CINODE		},
    { "msi",		"msinode",	MSINODE		},
    { "\0",		"\0",		UNKNOWN		}
};

/********************************************************************
 *
 * Table Structure for configuring the CPU information.
 *
 *  All this does is map the cpu define to a string that is passed
 *  back that allows the user command "sizer" to controll what files
 *  are loaded for a given kernel.  Any file in the files.hal file
 *  that has a cpu type string that matches is configured into a kernel.
 *
 *******************************************************************/
volatile struct config_cpu cputbl[] = {
#ifndef __alpha
    { DS_3100,      "DS3100",  		0,	 "\0"      }, 
    { DS_5000,      "DS5000",		0,	 "\0"      }, 
    { DS_5000_100,  "DS5000_100",	0,	 "\0"      }, 
    { DS_5000_300,  "DS5000_300",	0,	 "\0"      }, 
    { DS_MAXINE,    "DSPERSONAL_DECSTATION", 0, "\0"      },
    { DS_5100,      "DS5100",		0,	 "\0"      }, 
    { DS_5400,      "DS5400",		0,	 "\0"      }, 
    { DS_5500,      "DS5500",		0,	 "\0"      }, 
    { DS_5800,      "DS5800",		0,	 "\0"      }, 
#endif
#ifdef __alpha
    { ALPHA_ADU,    "ALPHAADU",		0,	 "\0"      }, 
    { DEC_4000,     "DEC4000",		0,	 "\0"      }, 
    { DEC_2100_A500,"DEC2100_A500",	0,	 "\0"	   },
    { DEC_2100_C500,"DEC2100_C500",	0,	 "\0"	   },
    { DEC_3000_500, "DEC3000_500",	0,	 "\0"      }, 
    { DEC_3000_300, "DEC3000_300",	0,	 "\0"      }, 
    { DEC_2000_300, "DEC2000_300",	0,	 "\0"      }, 
    { ALPHA_KN20AA, "DEC_KN20AA",	0,	 "\0"	   },
    { DEC_AXPPCI_33,"DECAXPPCI_33",	0,	 "\0"	   },
    { DEC_2100_A50, "DEC2100_A50",	0,	 "\0"	   },
    { DEC_AXPVME_64,"DECAXPVME_64",	0,	 "\0"	   },
    { DEC_7000,     "DEC7000",		0,	 "\0"      }, 
    { DEC_21000,    "DEC21000",		0,	 "\0"      }, 
    { DEC_1000,     "DEC1000",		0,	 "\0"	   },
    { EB64_PLUS,    "ALPHAPC64",        0,      "\0"      },
    { LCA_EB66,     "EB66PLUS",         0,      "\0"      },
    { ALPHA_EB164,  "EB164",            0,      "\0"      },
    { DEC_EV45_PBP, "DECEV45_PBP",	0,      "\0"      },
    { DEC_1000A,    "DEC1000A",		0,      "\0"      },
    { DEC_4100,     "DEC4100",		0,	 "\0"	   },
    { DEC_ALPHAVME_224, "DECALPHAVME_224", 0,   "\0"      },
    { DEC_1000_5,   "DEC1000_5",        0,      "\0"      },
    { DEC_1000A_5,  "DEC1000A_5",       0,      "\0"      },
    { DEC_EV56_PBP, "DECEV56_PBP",      0,      "\0"      },
    { ALPHABOOK_1,  "ALPHABOOK1",       0,      "\0"      },
    { DEC_ALPHAVME_320, "DECALPHAVME_320", 0,   "\0"      },
    { DEC_550, 		"DECST30", 	0,	 "\0"      },
    { DEC_6600,		"DEC6600", 	0,	 "\0"      },
    { DMCC_EV6,		"DMCCEV6", 	0,	 "\0"      },
    { ALPHA_WILDFIRE,"ALPHAWILDFIRE",	0,	 "\0"      },
    { ALPHA_TITAN,"ALPHATITAN",		0,	 "\0"      },
    { ALPHA_MARVEL,"ALPHAMARVEL",       0,       "\0"      },
    { ALPHA_RAPTOR,"ALPHARAPTOR",       0,       "\0"      },
#endif
    { UNKNOWN,	    "UNDEFINED_CPU",	0,	 "\0"  	   } 
};

/********************************************************************
 *
 * Table Structure for configuring the DEVICE information.
 *
 *******************************************************************/

volatile struct config_device devtbl[] = {
    { "ci",	"bus",            0,1,	"\0",		0, BUS },
    { "ibus",	"bus",            0,1,	"\0",		0, BUS },
    { "msi",	"bus",            0,1,	"msi_isr",	0, BUS },
    { "uba",	"bus",            0,1,	"\0",		0, BUS },
    { "bi",	"bus",            0,1,	"\0",		0, BUS },
    { "vba",	"bus",            0,1,	"\0",		0, BUS },
    { "xmi",	"bus",            0,1,	"xmierror",	0, BUS },
    { "tc",	"bus",            0,1,	"\0",		0, BUS },
    { "lbus",	"bus",            0,1,	"\0",		0, BUS },
    { "fbus",	"bus",            0,1,	"\0",		0, BUS },
    { "isa",	"bus",            0,1,	"\0",		0, BUS },
    { "eisa",	"bus",            0,1,	"\0",		0, BUS },
    { "pci",	"bus",            0,1,	"\0",		0, BUS },
    { "pcmcia",	"bus",            0,1,	"\0",		0, BUS },
    { "tlsb",	"bus",            0,1,	"\0",		0, BUS },
    { "mcbus",	"bus",            0,1,	"\0",		0, BUS },
    { "wfqbb",	"bus",            0,1,	"\0",   	0, BUS },
    { "wfiop",	"bus",            0,1,	"\0",   	0, BUS },
    { "tiop",	"bus",            0,1,	"tioperror",   	0, BUS },
    { "lsb",	"bus",            0,1,	"\0",		0, BUS },
    { "iop",	"bus",            0,1,	"ioperror",    	0, BUS },
    { "xza",	"bus",            0,1,	"\0",      	0, BUS },
    { "tcds",	"bus",		  0,1,	"tcdsintr",	0, BUS },
    { "asc",	"bus",	          0,1,	"ascintr",	0, BUS },
    { "aha",	"bus",     	  0,1,	"ahaintr",	0, BUS },
    { "tza",  	"bus",            0,1,  "tzaintr",   	0, BUS },
    { "pza",  	"bus",            0,1,  "pzaintr",   	0, BUS },
    { "siop",	"bus",            0,1,	"siopcointr",	0, BUS },
    { "psiop",	"bus",            0,1,	"psiopintr",	0, BUS },
    { "isp",    "bus",		  0,1,  "ispintr",	0, BUS },
    { "itpsa",  "bus",		  0,1,  "itpsaintr",	0, BUS },
    { "ata",	"bus",		  0,1,  "\0",		0, BUS },
    { "usb",	"bus",		  0,1,  "\0",		0, BUS },
    { "emx",	"bus",		  0,1,  "\0",		0, BUS },
    { "i2o",	"bus",		  0,1,  "\0",		0, BUS },
    { "i2o_bs",	"controller", 	  0,1,  "\0",		0, CONTROLLER },
    { "nvtc",	"controller",     0,1,	"nvtcintr",	0, CONTROLLER },
    { "envram",	"controller",     0,1,	"\0",	        0, CONTROLLER },
    { "pnvram",	"controller",     0,1,	"\0",	        0, CONTROLLER },
    { "aie",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "aio",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "xcr",	"controller",     0,1,	"xcrintr",	0, CONTROLLER },
    { "bvpssp",	"controller",     0,1,	"bvpsspintr",	0, CONTROLLER },
    { "dc",	"controller",     1,1,	"dcintr",	0, CONTROLLER },
    { "ace",	"controller",     1,1,	"aceintr",	0, CONTROLLER },
    { "iscc", 	"controller",     1,1,	"\0",		0, CONTROLLER },
    { "gpc",	"controller",     0,1,	"gpcintr",	0, CONTROLLER },
    { "lp",	"controller",	  1,1,	"lpintr",	0, CONTROLLER },
    { "dssc",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "dti",	"controller",	  1,1,	"dtiintr",	0, CONTROLLER },
    { "fx",	"controller",     0,0,	"rxintr",	0, CONTROLLER },
    { "fdi",	"controller",	  0,1,	"\0",		0, CONTROLLER },
    { "hk",	"controller",     0,0,	"rkintr",	0, CONTROLLER },
    { "hl",	"controller",     0,0,	"rlintr",	0, CONTROLLER },
    { "hmc",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "hsc",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "idc",	"controller",     0,0,	"idcintr",	0, CONTROLLER },
    { "kdb",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "kdm",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "klesib",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "klesiu",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "ln",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "le",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "tu",	"controller",	  0,1,	"\0",		0, CONTROLLER },
    { "alt",	"controller",	  0,1,	"\0",		0, CONTROLLER },
    { "el",	"controller",     0,0,	"\0",		0, CONTROLLER },
    { "fza",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "fta",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "tra",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "lta",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "te",	"controller",	  0,1,	"teintr",	0, CONTROLLER },
    { "xna",	"controller",	  0,1,	"xnaintr", 	0, CONTROLLER },
    { "mfa",	"controller",	  0,1,	"mfaintr", 	0, CONTROLLER },
    { "rqd",	"controller",     0,0,	"\0",		0, CONTROLLER },
    { "sc",	"controller",     0,1,	"upintr",	0, CONTROLLER },
    { "scsi",	"controller",     0,1,	"\0",    	0, CONTROLLER },
    { "sdc",	"controller",     0,1,	"sdintr",	0, CONTROLLER },
    { "stc",	"controller",     0,1,	"stintr",	0, CONTROLLER },
    { "tm",	"controller",     0,0,	"tmintr",	0, CONTROLLER },
    { "uda",	"controller",     0,1,	"\0",		0, CONTROLLER },
    { "uq",	"controller",     0,1,	"uqintr",	0, CONTROLLER },
    { "ut",	"controller",     0,0,	"utintr",	0, CONTROLLER },
    { "va",	"controller",     0,0,	"\0",		0, CONTROLLER },
    { "vb",     "controller",     0,1,  "\0",       	0, CONTROLLER },
    { "zs",	"controller",     0,0,	"tsintr",	0, CONTROLLER },
    { "cfb",	"controller",     0,1,	"cfbvint", 	0, CONTROLLER },
    { "fb",	"controller",     0,1,	"fbint", 	0, CONTROLLER },
    { "px",	"controller",     0,1,	"pxintr", 	0, CONTROLLER },
    { "pv",	"controller",     0,1,	"pvintr", 	0, CONTROLLER },
    { "pvl",	"controller",     0,1,	"pvlintr", 	0, CONTROLLER },
    { "vga",	"controller",     0,1,	"\0", 	        0, CONTROLLER },
    { "ati_vga","controller",     0,1,	"\0", 	        0, CONTROLLER },
    { "qvision","controller",     0,1,	"\0", 	        0, CONTROLLER },
    { "ati64_vga", "controller",     0,1,	"\0", 	        0, CONTROLLER },
    { "cirrus",	"controller",     0,1,	"\0", 	        0, CONTROLLER },
    { "s3trio",	"controller",     0,1,	"\0", 	        0, CONTROLLER },
    { "svision","controller",     0,1,	"\0", 	        0, CONTROLLER },
    { "comet",  "controller",     0,1,  "\0",           0, CONTROLLER },
    { "tga",	"controller",     0,1,	"\0",           0, CONTROLLER },
    { "p3g",	"controller",     0,1,	"\0",           0, CONTROLLER },
    { "radeon",	"controller",	  0,1,	"\0",		0, CONTROLLER },
    { "pvp",	"controller",     0,1,	"\0",           0, CONTROLLER },
    { "wd",	"controller",     0,1,	"\0",           0, CONTROLLER },
    { "scc", 	"controller",     1,1,	"sccintr",	0, CONTROLLER },
    { "bba",	"controller",	  0,1,	"bbaintr",	0, CONTROLLER },
    { "mchan",	"controller",	  0,1,	"\0",		0, CONTROLLER },
    { "ra",	"device disk",    1,1,	"\0",		0, DISK },
    { "rb",	"device disk",    1,0,	"\0",		0, DISK },
    { "rd",	"device disk",    1,0,	"\0",		0, DISK },
    { "ri",	"device disk",	  1,1,	"\0",		0, DISK },
    { "rk",	"device disk",	  1,0,	"\0",		0, DISK },
    { "rl",	"device disk",	  1,0,	"\0",		0, DISK },
    { "rx",	"device disk",	  1,1,	"\0",		0, DISK },
    { "rz",	"device disk",	  1,1,	"\0",		0, DISK },
    { "re",	"device disk",	  1,1,	"\0",		0, DISK },
    { "up",	"device disk",	  1,0,	"\0",		0, DISK },
    { "urx",	"device disk",	  1,0,	"\0",		0, DISK },
    { "vz",	"device disk",	  1,0,	"\0",		0, DISK },
    { "mu",	"device tape",	  1,0,	"\0",		0, TAPE },
    { "st",	"device tape",	  1,0,	"\0",		0, TAPE },
    { "tj",	"device tape",	  1,0,	"\0",		0, TAPE },
    { "tms",	"device tape",	  1,1,	"\0",		0, TAPE },
    { "ts",	"device tape",	  1,0,	"\0",		0, TAPE },
    { "tz",	"device tape",	  1,1,	"\0",		0, TAPE },
    { "fd",	"device disk",	  1,1,	"\0",		0, DISK },
    { "acc",	"device",	  0,0,	"accrint accxint",0, DEVICE },
    { "ad",	"device",	  1,0,	"\0",		0, DEVICE },
    { "bvpni", 	"device",	  0,1,	"bvpniintr",	0, DEVICE },
    { "css",	"device",	  0,0,	"cssrint cssxint",0xa, DEVICE },
    { "ct",	"device",	  1,0,	"\0", 		0, DEVICE },
    { "de",	"device",	  0,1,	"deintr",	0, DEVICE },
    { "dh",	"device",	  1,0,	"dhrint dhxint",0xffff, DEVICE },
    { "dhu",	"device",	  1,1,	"dhurint dhuxint",0xffff, DEVICE },
    { "dm",	"device",	  1,0,	"dmintr", 	0xffff, DEVICE },
    { "dmb",	"device",	  1,1,	"dmbsint dmbaint dmblint",0xff, DEVICE },
    { "dmc",	"device",	  0,0,	"dmcrint dmcxint",0, DEVICE },
    { "dmf",	"device",	  1,0,
	      "dmfsrint dmfsxint dmfdaint dmfdbint dmfrint dmfxint dmflint", 
	      0xff, DEVICE },
    { "dmv",	"device",	  0,0,	"dmvrint dmvxint",0, DEVICE },
    { "dmz",	"device",	  1,0,
      	      "dmzrinta dmzxinta dmzrintb dmzxintb dmzrintc dmzxintc",
	      0xffffff, DEVICE },
    { "dn",	"device",	  0,0,	"dnintr",	0, DEVICE },
    { "dpv",	"device",	  0,0,	"dpvrint dpvxint",0, DEVICE },
    { "dup",	"device",	  0,0,	"duprint dupxint",0, DEVICE },
    { "dz",	"device",	  1,0,	"dzrint dzxint",0xff, DEVICE },
    { "ec",	"device",	  0,0,	"ecrint ecxint eccollide",0, DEVICE },
    { "en",	"device",	  0,0,	"enrint enxint encollide", 0, DEVICE },
    { "fc",	"device",	  1,0,	"fcxrint",	0xf, DEVICE },
    { "fg",	"device",	  1,0,	"fgvint",	0xf, DEVICE },
    { "ga",	"device",	  0,1,	"gaintr", 	0, DEVICE },
    { "gq",	"device",	  0,1,	"gqintr", 	0, DEVICE },
    { "hy",	"device",	  0,0,	"hyint",	0, DEVICE },
    { "ik",	"device",	  1,0,	"ikintr", 	0, DEVICE },
    { "il",	"device",	  0,0,	"ilrint ilcint",0, DEVICE },
    { "kg",	"device",	  1,0,	"\0", 		0, DEVICE },
    { "lx",	"device",	  1,0, 	"lxbvpint",	0, DEVICE },
    { "mdc",	"device",	  1,1, 	"mdcintr",	0, DEVICE },
    { "pcl",	"device",	  0,0,	"pclxint pclrint",0, DEVICE },
    { "pm",	"device",	  0,1,	"pmvint", 	0, DEVICE },
    { "ps",	"device",	  1,0,	"\0", 		0, DEVICE },
    { "qd",	"device",	  1,0,	"qddint qdaint qdiint",	0xf, DEVICE },
    { "qv",	"device",	  1,0,	"qvkint qvvint",0xf, DEVICE },
    { "sg",	"device",	  1,0,	"sgaint sgfint",0xf, DEVICE },
    { "sh",	"device",	  1,0,	"shrint shxint",0xff, DEVICE },
    { "sm",	"device",	  1,0,	"smvint",	0xf, DEVICE },
    { "ss",	"device",	  1,0,	"ssrint ssxint",0xf, DEVICE },
    { "sz",	"device",	  0,1,	"\0",		0, DEVICE },
    { "un",	"device",	  0,0,	"unintr",	0, DEVICE },
    { "uu",	"device",	  1,0,	"\0", 		0, DEVICE },
    { "vp",	"device",	  1,0,	"vpintr",	0, DEVICE },
    { "vv",	"device",	  1,0,	"vvrint vvxint",0, DEVICE },
    { "\0",	"",               0,0,	"\0", 		0, DEVICE }
};


/********************************************************************
 *
 * Table Structure for defining the configuration file HARDWARE
 * NAME types.
 *
 *******************************************************************/
volatile struct hardware hardtbl[] = {
    { "bus"		},
    { "controller"	},
    { "master"		},
    { "disk"		},
    { "tape"		},
    { "device"		},
    { "\0"		}
};

#ifndef __alpha
/********************************************************************
 *
 * Table Structure for defining the FLOATING ADDRESS DEVICES that
 * we need to search for.
 *
 *******************************************************************/
volatile struct float_devices floattbl[] = {
	{ "dj11",	04 	},	
	{ "dh",		010 	},	
	{ "dq11",	04 	}, 
	{ "du11",	04 	}, 	
	{ "dup",	04 	},	
	{ "lk11",	04 	}, 
	{ "dmc", 	04 	},	
	{ "dz", 	04 	}, 	
	{ "kmc11",	04 	}, 
	{ "lpp11", 	04 	},	
	{ "vmv21",	04 	},	
	{ "vmv31",	010 	},
	{ "dwr70", 	04 	},	
	{ "hl",		04 	},	
	{ "kw11c", 	04 	}, 	
	{ "rsv",	04 	},	
	{ "fx",   	04 	}, 
	{ "un",	 	04 	},	
	{ "hy",   	04 	}, 	
	{ "dmp11",	04 	}, 
	{ "dpv",  	04 	},	
	{ "isb11",	04 	},	
	{ "dmv", 	010 	},
	{ "de",	 	04 	},	
	{ "uda",	02 	},	
	{ "dmf",  	020 	},
	{ "kms11", 	010 	}, 	
	{ "vs100",	010 	},	
	{ "klesiu",	02 	},
	{ "kmv11", 	010 	},	
	{ "dhu",  	010 	}, 	
	{ "dmz", 	020 	},
	{ "cpi32",	020 	},	
	{ "qvss",	040 	},
	{ "vs31",	04 	}, 
	{ "dtqna", 	04 	},	
	{ "csam",	04 	},	
	{ "adv11c",	04 	},
	{ "aav11c",	04 	}, 	
	{ "axv11c",	04 	},	
	{ "kwv11c",	02 	},
	{ "adv11d", 	04 	},	
	{ "aav11d",	04 	}, 	
	{ "drq3p", 	04 	},
	{ "\0", 	0  	}
};
volatile int Flttblsize  = (sizeof(floattbl)/sizeof(floattbl[0]));
#endif

/* Define the sizes in bytes of all the above tables */
volatile int NodetblB = sizeof(nodetbl);
volatile int CputblB  = sizeof(cputbl);
volatile int DevtblB  = sizeof(devtbl);
volatile int HardtblB = sizeof(hardtbl);

/* Define the sizes in num entrues of all the above tables */
volatile int Nodetblsize = (sizeof(nodetbl)/sizeof(nodetbl[0]));
volatile int Cputblsize  = (sizeof(cputbl)/sizeof(cputbl[0]));
volatile int Devtblsize  = (sizeof(devtbl)/sizeof(devtbl[0]));
volatile int Hardtblsize = (sizeof(hardtbl)/sizeof(hardtbl[0]));

extern int cpu;
char * configcpu_string;

/****************************************************************
*    getcpu							*
*    								*
*    Get cpu type that this program is running on.		*
****************************************************************/
char *
getcpustring()
{
  int index;

  /* Set defatult type to unknown, its there somewhere */
  for(index = 0; index < Cputblsize - 1; index++) {
    if( UNKN_SYSTEM == cputbl[index].cputype){
      configcpu_string = cputbl[index].cpuname;
      break;
    }
  }

  /* Find real cpu type in the "cputbl" table if its there */
  for(index = 0; index < Cputblsize - 1; index++) {
    if( cpu == cputbl[index].cputype){
      configcpu_string = cputbl[index].cpuname;
      break;
    }
  }
  return(configcpu_string);
}
